// Student.cpp: implementation of the Student class.
//
//////////////////////////////////////////////////////////////////////

#include "Student.h"
#include <iostream>
using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Student::Student(string fnarg, string lnarg, int agearg, double ssarg, double GPAarg) :
// Here you'd like to say
// firstName(fnarg), lastName(lnarg), age(ageArg), shoeSize(ssarg), GPA(GPAarg)
// but this method isn't allowed access to the instance variables firstName,
// lastName, age, and shoeSize because they're private in Person.  So we invoke
// the Person constructor to initialize them, and have our own initializer for GPA:
Person(fnarg, lnarg, agearg, ssarg), GPA(GPAarg)
{

}

Student::~Student()
{

}

ostream& Student::put (ostream& s) const
{
Person::put(s); // invokes the Person version of "put" before going on.
return s << "The GPA is " << GPA << "."; // extra information
}

// Note that I didn't need to re-define the overloaded << operator, which was written to simply
// invoke "put".  It still does that, so it doesn't need to change.
// But now I've written a new version of "put" that overrides the old one.
// A neat aspect of this is that the old "<<" operator is now using the new "put" method,
// and I haven't had to rewrite the old "<<" operator at all.
// "Polymorphism is the ability for code written today to use objects defined tomorrow
// without modifying the code written today."
// (Not a complete definition of polymorphism, but applicable to the current situation.)
