// Student.h: interface for the Student class.
// "Student" is no longer an independent class; it is now defined as a subclass of "Person",
// so it automatically inherits the methods and instance variables of Person.
//
//////////////////////////////////////////////////////////////////////

#ifndef _STUDENT_H_
#define _STUDENT_H_

#include <string>
using namespace std;
#include "Person.h"

class Student  : public Person   // C++ syntax for subclasses
{
public:
	Student(string fnarg, string lnarg, int agearg, double ssarg, double GPAarg);
	virtual ~Student();

	// Note that I haven't bothered re-declaring "birthday" or the operator overloading,
	// as they're inherited automatically from Person.  I've re-declared the constructor
	// because constructors can't be inherited, and I've re-declared the "put" method
	// because I'm defining my own version of it that overrides the inherited version.
	
	virtual ostream& put (ostream& s) const;


private:
	double GPA;
	// Again, no need to re-declare the instance variables inherited from Person.
};


#endif