#include <iostream>
#include <string>
#include "Pet.h"
#include "Dog.h"
#include "Cat.h"
#include "Fish.h"
#include "Bird.h"
#include "Emu.h"
using namespace std;

int main (void)
{
	Dog jimmy(20, 3, true);
	Dog *amy = new Dog(45);

	cout << "Jimmy: " << jimmy.description () <<
		" should be a 20-lb, 3-year-old dog who can sit but not stay" << endl;
	cout << "Amy: " << amy->description () <<
		" should be a 45-pound dog (other values defaulted)" << endl;

	Cat jane(10,7);
	Cat *michael = new Cat(5.6,2);

	cout << "Jane: " << jane.description () <<
		" should be a 10-lb, 7-year-old cat" << endl;
	cout << "Michael: " << michael->description () <<
		" should be a 5.6-lb, 2-year-old cat" << endl;

	Fish freddie(.01);
	Fish *phil;
	phil = new Fish(.02,3);

	cout << "Freddie: " << freddie.description() <<
		" should be a .01-lb fish" << endl;
	cout << "Phil: " << phil->description() <<
		" should be a .02-lb, 3-year-old fish" << endl;

	Bird tweety(.2,2);

	cout << "Tweety: " << tweety.description() <<
		" should be a 0.2-lb, 2-year-old bird" << endl;

	Emu emma (35, 6);

	cout << "Emma: " << emma.description() <<
		" should be a 35-lb, 6-year-old emu" << endl;

	/* Pet jimmyAsPet = jimmy; */
	// The above line doesn't compile because it creates a Pet that isn't
	// any specific kind of Pet.  Even though jimmy is a Dog, assigning
	// jimmy to a Pet variable throws away the extra information that
	// distinguishes Dogs from other kinds of Pets.
	Pet *jimmyAsPet = &jimmy;
	Pet *amyAsPet = amy;
	Pet *janeAsPet = &jane;
	Pet *michaelAsPet = michael;
	Pet *freddieAsPet = &freddie;
	Pet *philAsPet = phil;
	Pet *tweetyAsPet = &tweety;
	Pet *emmaAsPet = &emma;

	cout << "Now let's look at them through Pet variables:" << endl;
	cout << "Jimmy: " << jimmyAsPet->description() << endl;
	cout << "Amy: " << amyAsPet->description() << endl;
	cout << "Jane: " << janeAsPet->description() << endl;
	cout << "Michael: " << michaelAsPet->description() << endl;
	cout << "Freddie: " << freddieAsPet->description() << endl;
	cout << "Phil: " << philAsPet->description() << endl;
	cout << "Tweety: " << tweetyAsPet->description() << endl;
	cout << "Emma: " << emmaAsPet->description() << endl;


	cout << "Who fits in a 10-pound cage?" << endl;
	if (jimmy.fitsInCage(10)) cout << "Jimmy,";
	if (amy->fitsInCage(10)) cout << "Amy, ";
	if (jane.fitsInCage(10)) cout << "Jane, ";
	if (michael->fitsInCage(10)) cout << "Michael, ";
	if (freddie.fitsInCage(10)) cout << "Freddie, ";
	if (phil->fitsInCage(10)) cout << "Phil, ";
	if (tweety.fitsInCage(10)) cout << "Tweety, ";
	if (emma.fitsInCage(10)) cout << "Tweety, ";
	if (jimmyAsPet->fitsInCage(10)) cout << "Jimmy as Pet, ";
	if (amyAsPet->fitsInCage(10)) cout << "Amy as Pet, ";
	if (janeAsPet->fitsInCage(10)) cout << "Jane as Pet, ";
	if (michaelAsPet->fitsInCage(10)) cout << "Michael as Pet, ";
	if (freddieAsPet->fitsInCage(10)) cout << "Freddie as Pet, ";
	if (philAsPet->fitsInCage(10)) cout << "Phil as Pet, ";
	// Note that Freddie and Phil fit in a 10-pound cage when treated as Pets,
	// but not when treated as Fish.  This is because the "fitsInCage" method
	// wasn't declared "virtual".
	if (tweetyAsPet->fitsInCage(10)) cout << "Tweety as Pet ";
	if (emmaAsPet->fitsInCage(10)) cout << "Emma as Pet ";
	cout << endl;
}
